#!/bin/sh

# adapt paths
TRIPLE=~/project/triple
XSB=~/bin/xsb
# XOPTION=-Xbootclasspath/p:$TRIPLE/lib/xerces.jar # for JDK1.4.X
# end adapt

CLASSES=$TRIPLE/java/classes:$TRIPLE/java/resources:$TRIPLE/lib/jena.jar:$TRIPLE/lib/rdf-api-2001-01-19.jar:$TRIPLE/lib/xerces.jar

echo compiling $* ...
java $XOPTION -cp $CLASSES org.semanticweb.triple.application.Commandline $*

echo running $* ...
$XSB --nobanner --quietload --noprompt -e "['#out']."

echo done.
