/*
 * DAMLSyntax.java
 *
 * Created on March 3, 2002, 11:16 AM
 */

package org.semanticweb.dl;

import java.util.*;


/**
 * DAML syntax.
 * @author  Michael Sintek
 * @version 
 */
public class DAMLSyntax extends Syntax {

  // DAML syntax only works for RACER output at the moment,
  // only Implies, and Equal are supported.
  
  public DAMLSyntax(KB kb) {
    super(kb);
  }
  
  public boolean LISP() { return false; }
  public boolean DAML() { return true; }
  
  public boolean showDefconcept() { return false; }
  public boolean showDefrole() { return false; }

  public String abbrevSplitter() { return ":"; }

}
