package org.semanticweb.triple.inference;

import java.io.*;
import java.util.*;
import java.net.*;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 16, 2002
 */
public class Atom extends GroundAtom {
// shoudnt be it should be the other way round. ?
// ground groundatom is more specialized and extends ground atom
// I guess the reason is ground atom was defined first.

    /**
     *  Description of the Field
     */
    public static long no = 0;
    /**
     *  Description of the Field
     */
    public Variable variables = null;
    // verkettete Liste von Variablen des Atoms
    /**
     *  Description of the Field
     */
    public int anzvars = 0;
    // no of variables
    int maxvarsym = -1;
    // max variable symbol of atom
    /**
     *  Description of the Field
     */
    public long vars = 0;
    // Bitleiste der Variablen
    /**
     *  Description of the Field
     */
    public int rule = -1;


    /**
     *  Constructor for the Atom object
     *
     *@param  t  Description of the Parameter
     */
    public Atom(Term t[]) {
        super(t);
        Variables();
        no++;
    }


    /**
     *  Constructor for the Atom object
     *
     *@param  anz  Description of the Parameter
     */
    public Atom(int anz) {
        super(anz);
        variables = null;
        no++;
    }


    /**
     *  Description of the Method
     */
    public void ClearVariables() {
        // delete all variables substitutions
        Variable v;
        for (v = variables; v != null; v = v.next) {
            v.subsby = null;
        }
    }


    /**
     *  Description of the Method
     *
     *@param  index  Description of the Parameter
     *@param  len    Description of the Parameter
     *@return        Description of the Return Value
     */
    public Atom Extend(int index[], int len) {
        // legt ein neues Atom B der Lnge len an. Alle Terme an der Stelle i in A werden an die Stelle index[i]
        // in B kopiert. Alle anderen Stellen in B werden durch Variablen aufgefllt
        Atom tnew;
        int i;
        tnew = new Atom(len);
        tnew.and = true;
        // copy terms
        for (i = 0; index[i] != -1; i++) {
            tnew.terms[index[i]] = this.terms[i];
        }
        // ergnze um Variablen
        for (i = 0; i < len; i++) {
            if (tnew.terms[i] == null) {
                tnew.terms[i] = new Variable(i);
            }
        }
        // registriere Variablen
        tnew.Variables();
        this.Supports(tnew);
        return tnew;
    }


    /**
     *  Description of the Method
     *
     *@param  A  Description of the Parameter
     *@return    Description of the Return Value
     */
    public Atom Generalize(Atom A) {
        Atom t = null;
        int i;
        int max;
        Variable v;
        boolean res = true;
        if ((this != A) && (CompareAtoms(A) != 0)) {
            // Umbenennen von Variablen
            if (A.maxvarsym > maxvarsym) {
                max = A.maxvarsym;
            }
            else {
                max = maxvarsym;
            }
            // Retten und Umbenennen von Variablen
            for (v = A.variables; v != null; v = v.next) {
                v.hsymbol = v.symbol;
                v.symbol += max + 1;
            }

            for (v = variables; v != null; v = v.next) {
                v.hsymbol = v.symbol;
            }
            // Unifikation
            for (i = 0; (i < terms.length) && res; i++) {
                res = terms[i].Unify(A.terms[i]);
            }
            if (res) {
                this.ClearVariables();
                A.ClearVariables();
                t = new Atom(terms.length);
                for (i = 0; i < terms.length; i++) {
                    t.terms[i] = this.terms[i].Generalize(A.terms[i]);
                }
                t.Variables();
            }
            // Zurueckbenennen von Variablen
            for (v = A.variables; v != null; v = v.next) {
                v.symbol = v.hsymbol;
            }
            for (v = variables; v != null; v = v.next) {
                v.symbol = v.hsymbol;
            }
        }
        return t;
    }


    /**
     *  Gets the marked attribute of the Atom object
     *
     *@param  i  Description of the Parameter
     *@return    The marked value
     */
    public boolean isMarked(int i) {
        // fragt in den Markierungen Bit i ab
        if (((1 << i) & mark) != 0) {
            return true;
        }
        else {
            return false;
        }
    }


    /**
     *  Description of the Method
     *
     *@param  i  Description of the Parameter
     */
    public void Mark(int i) {
        // setzt in den Markierungen Bit i
        mark |= (1 << i);
    }


    /**
     *  Description of the Method
     *
     *@param  i  Description of the Parameter
     */
    public void MarkVar(int i) {
        // setzt in den Variablenmarkierungen Bit i
        vars |= (1 << i);
    }


    /**
     *  Description of the Method
     *
     *@param  A  Description of the Parameter
     *@return    Description of the Return Value
     */
    public boolean Match(GroundAtom A) {
        // Matcht Atom mit Atom A
        int i;
        // Variable v;
        boolean res = true;
        for (i = 0; (i < terms.length) && res; i++) {
            res = terms[i].Match(A.terms[i]);
        }
        return res;
    }


    /**
     *  Description of the Method
     *
     *@param  A  Description of the Parameter
     *@return    Description of the Return Value
     */
    public boolean Unify(Atom A) {
        // Unifiziert zwei Atome miteinander
        int max;
        // Unifiziert zwei Atome miteinander
        int i;
        Variable v;
        boolean res = true;
        if (A.maxvarsym > maxvarsym) {
            max = A.maxvarsym;
        }
        else {
            max = maxvarsym;
        }
        // Retten und Umbenennen von Variablen
        for (v = A.variables; v != null; v = v.next) {
            v.hsymbol = v.symbol;
            v.symbol += max + 1;
        }

        for (v = variables; v != null; v = v.next) {
            v.hsymbol = v.symbol;
        }
        // Unifikation
        for (i = 0; (i < terms.length) && res; i++) {
            res = terms[i].Unify(A.terms[i]);
        }
        // Zurueckbenennen von Variablen
        for (v = A.variables; v != null; v = v.next) {
            v.symbol = v.hsymbol;
        }
        for (v = variables; v != null; v = v.next) {
            v.symbol = v.hsymbol;
        }
        return res;
    }


    /**
     *  Description of the Method
     */
    public void Variables() {
        // initialize the variables
        int i;
        variables = null;
        anzvars = 0;
        maxvarsym = -1;
        vars = 0;
        for (i = terms.length - 1; i >= 0; i--) {
            terms[i] = addVariables(terms[i]);
        }
    }


    /**
     *  Adds a feature to the Variables attribute of the Atom object
     *
     *@param  t  The feature to be added to the Variables attribute
     *@return    Description of the Return Value
     */
    private Term addVariables(Term t) {
        Variable v;
        int i;
        if (!t.ground) {
            if (t instanceof Variable) {
                Variable termVar = (Variable) t;
                // if  term is a variable add variable to list of variables (at the beginning)
                for (v = variables; (v != null) && (v.symbol != termVar.symbol); v = v.next) {
                    ;
                }
                if (v == null) {
                    termVar.next = variables;
                    variables = termVar;
                    // update maxsymbol if necessary
                    if (termVar.symbol > maxvarsym) {
                        maxvarsym = termVar.symbol;
                    }
                    anzvars++;
                    // vars  is a bitvector representing the ground status!!!!
                    // that means the number of arguments is limited to number of bits
                    // in a long, that means 64!
                    vars = vars | (1L << termVar.symbol);
                    return t;
                }
                else {
                    // variable already in term...
                    t = null;
                    //return found variable instead of term supplied (why?)
                    return v;
                }
            }
            else
            // do it recursivly
                    if (t.anzpars() > 0) {
                for (i = 0; i < t.anzpars(); i++) {
                    t.pars[i] = addVariables(t.pars[i]);
                }
            }
        }
        return t;
    }
}
