package org.semanticweb.triple.inference;

/*
 *  Name: Atoms.java
 *  Version: 2.0
 *  Purpose: a container for atoms with appropriate access data structures
 *  (AVL trees)
 *  History:
 */
import java.io.*;
import java.util.*;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
class Enumeration {
    IndexEnumeration enm;
    Atoms R1;


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public GroundAtom Enum() {
        enm = R1.indices.avl.elements();
        if (enm.hasMoreElements()) {
            return (GroundAtom) enm.nextElement();
        }
        else {
            return null;
        }
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public GroundAtom EnumNext() {
        if (enm.hasMoreElements()) {
            return (GroundAtom) enm.nextElement();
        }
        else {
            return null;
        }
    }
}
