package org.semanticweb.triple.inference;

import java.io.*;
import java.util.*;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
class IndexNode {
    /**
     *  Description of the Field
     */
    protected int svec[];
    /**
     *  Description of the Field
     */
    protected int stellen = 0;
    /**
     *  Description of the Field
     */
    protected int anzstellen = 0;
    /**
     *  Description of the Field
     */
    protected IndexNode next;
    /**
     *  Description of the Field
     */
    protected IndexInterface avl;
    /**
     *  Description of the Field
     */
    protected CompareGroundAtoms comp;


    /**
     *  Constructor for the IndexNode object
     *
     *@param  index  Description of the Parameter
     *@param  dups   Description of the Parameter
     */
    protected IndexNode(int index[], boolean dups) {
        int i;
        stellen = 0;
        for (i = 0; index[i] != -1; i++) {
            stellen |= (1 << index[i]);
        }
        svec = index;
        anzstellen = i;
        comp = new CompareGroundAtoms(index, index);
        avl = new AVLTree(dups, comp);
        next = null;
    }
}
