package org.semanticweb.triple.inference.builtins;
import java.lang.*;
import java.util.*;
import org.semanticweb.triple.inference.Atom;
import org.semanticweb.triple.inference.Variable;
import org.semanticweb.triple.inference.Term;
import org.semanticweb.triple.inference.BuiltinFunc;
import org.semanticweb.triple.inference.NumTerm;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class ends extends BuiltinFunc {
    static Hashtable Ht = new Hashtable();


    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     */
    public void eval(Atom t) {
        Atom t1;
        Term trms[];
        t1 = (Atom) Ht.get(t.terms[0].toString());
        if (t.terms[1] instanceof NumTerm) {
            if (t1 == null) {
                insert(t);
                Ht.put(t.terms[0].toString(), t);
                lives.instance.reeval(t.terms[0]);
            }
            else if (((NumTerm) t1.terms[1]).zahl == ((NumTerm) t.terms[1]).zahl) {
                insert(t1);
            }
            else if (((NumTerm) t1.terms[1]).zahl > ((NumTerm) t.terms[1]).zahl) {
                retract(t1);
                if (!t.deleted) {
                    insert(t);
                    Ht.put(t.terms[0].toString(), t);
                    lives.instance.reeval(t.terms[0]);
                }
            }
        }
        else if ((t.terms[1] instanceof Variable) && (t1 != null)) {
            insert(t1);
        }
    }


    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     *@return    Description of the Return Value
     */
    public boolean evaluable(Atom t) {
        if (t.terms[0].ground && ((t.terms[1] instanceof NumTerm) || (t.terms[1] instanceof Variable))) {
            return true;
        }
        else {
            return false;
        }
    }
}
