package org.semanticweb.triple.language;

import java.util.*;
import org.semanticweb.glp.*;


public class Literal extends Term {

  String name;

  public Literal() {}

  public Literal(String name) {
    this.name = name;
  }

  // name or label ???
  public void putName(String name) { this.name = name; }

  public String getName() { return name; }

  // public getLiteral() -> export as rdfs:Literal !!! ???

  public String toString(Syntax syntax) {
    return syntax.getSymbol(name);
  }

  public GLPTerm toGLP(GLPTerm glpModel, ArrayList glpFormulae) {
    return new GLPTermConstant(name);
  }
  
}
