/*
 * Inverse.java
 *
 * Created on February 18, 2002, 5:10 PM
 */

package org.semanticweb.dl;

import java.io.*;


/**
 * Inverse role.
 * @author  Michael Sintek
 * @version 
 */
public class Inverse extends Expression {

  Expression _expr;
  
  /** Creates new Inverse */
  public Inverse(Expression expr) {
    _expr = expr;
  }
  
  public void print(Syntax syntax, PrintWriter out) {
    if (syntax.XML ()) {
      out.print ("<INVROLE>");
      _expr.print (syntax, out);
      out.print ("</INVROLE>");
    } else {
      out.print ("(inverse "); // inv in RACER -> syntax ... !!!
      _expr.print (syntax, out);
      out.println (")");
    }
  }
  
  public Expression toSHIQ(KB kb, int mode) {
    return new Inverse(_expr.toSHIQ(kb, ROLE));
  }

}

