package org.semanticweb.triple.inference;


/*
 *  Name: Recompiler.java
 *  Version: 1.0
 *  Purpose:
 *  History:
 */
import java.util.*;
import java.util.Date;
import java.net.*;
import java.io.*;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class Recompiler {
    /**
     *  Description of the Field
     */
    public static int STRINGSTART = 100000;
    /**
     *  Description of the Field
     */
    public String strings[];
    /**
     *  Description of the Field
     */
    public String predicates[];
    /**
     *  Description of the Field
     */
    public String functions[];



    /**
     *  Description of the Method
     *
     *@param  f                Description of the Parameter
     *@exception  IOException  Description of the Exception
     */
    public void readSymTab(RandomAccessFile f) throws IOException {
        int anzfsyms;
        int anzstrings;
        int anzpsyms;
        String s;
        int i;
        int index;
        int index1;
        int symbol;
        String str;
        int arity;
        int len;

        s = f.readLine();
        anzfsyms = wandle(s);
        functions = new String[anzfsyms];
        s = f.readLine();
        anzstrings = wandle(s);
        strings = new String[anzstrings];
        s = f.readLine();
        anzpsyms = wandle(s);
        predicates = new String[anzpsyms];

        for (i = 0; i < anzfsyms; i++) {
            s = f.readLine();

            index = s.indexOf(' ');
            symbol = wandle(s.substring(0, index));
            index1 = s.indexOf(' ', index + 1);
            //System.out.println(s); System.out.print("   ");
            // System.out.print(index); System.out.print(" "); System.out.println(index1);
            arity = wandle(s.substring(index + 1, index1));
            str = s.substring(index1 + 1);
            functions[symbol] = str;
            // FSymbols.searchAndInsert(str,arity);
        }

        for (i = 0; i < anzstrings; i++) {
            s = f.readLine();
            index = s.indexOf(' ');
            symbol = wandle(s.substring(0, index));
            if (i != symbol) {
                System.out.println("error in reading symbol table");
            }
            index1 = s.indexOf(' ', index + 1);
            //System.out.print(s); System.out.print("   ");
            // System.out.print(index); System.out.print(" "); System.out.println(index1);
            len = wandle(s.substring(index + 1, index1));
            str = s.substring(index1 + 1);
            while (str.length() < len - 1) {
                str = str + "\n" + f.readLine();
            }
            s = str.replace((char) 13, ' ');
            strings[symbol] = s;
        }

        for (i = 0; i < anzpsyms; i++) {
            s = f.readLine();
            index = s.indexOf(' ');
            symbol = wandle(s.substring(0, index));
            index1 = s.indexOf(' ', index + 1);
            //System.out.print(s); System.out.print("   ");
            // System.out.print(index); System.out.print(" "); System.out.println(index1);
            arity = wandle(s.substring(index + 1, index1));
            str = s.substring(index1 + 1);
            // PSymbols.searchAndInsert(str,arity);
            predicates[symbol] = str;

        }

    }


    /**
     *  Description of the Method
     *
     *@param  s  Description of the Parameter
     *@return    Description of the Return Value
     */
    int wandle(String s) {
        Integer zahl = new Integer(0);
        try {
            zahl = new Integer(s);
        } catch (NumberFormatException p) {
            System.out.println("number expected");
        }
        return zahl.intValue();
    }
}
